Index: tester/covoar/DesiredSymbols.cc
===================================================================
--- tester/covoar/DesiredSymbols.cc	(revision 09f4dbea55d1685f400e1475daed411a55ab74a7)
+++ tester/covoar/DesiredSymbols.cc	(revision 61410dbcc8d6521710702cf8ebc873058e1da0a4)
@@ -416,5 +416,5 @@
                       << d.first
                       << std::endl;
-            determineSourceLines( theRanges, d.second.sourceFile );
+          determineSourceLines( theRanges, d.second.sourceFile );
         }
 
Index: tester/covoar/GcovFunctionData.cc
===================================================================
--- tester/covoar/GcovFunctionData.cc	(revision 09f4dbea55d1685f400e1475daed411a55ab74a7)
+++ tester/covoar/GcovFunctionData.cc	(revision 61410dbcc8d6521710702cf8ebc873058e1da0a4)
@@ -6,8 +6,7 @@
  */
 
-#include <stdio.h>
-#include <string.h>
-//#include <stdlib.h>
-//#include <sys/stat.h>
+#include <cstdio>
+#include <cstring>
+#include <cinttypes>
 
 #include "app_common.h"
@@ -54,6 +53,6 @@
     if ( strlen(fcnName) >= FUNCTION_NAME_LENGTH ) {
       fprintf(
-        stderr, 
-        "ERROR: Function name is too long to be correctly stored: %u\n", 
+        stderr,
+        "ERROR: Function name is too long to be correctly stored: %u\n",
         (unsigned int) strlen(fcnName)
       );
@@ -90,7 +89,7 @@
     if ( strlen(fileName) >= FILE_NAME_LENGTH ){
       fprintf(
-        stderr, 
-        "ERROR: File name is too long to be correctly stored: %u\n", 
-        (unsigned int) strlen(fileName) 
+        stderr,
+        "ERROR: File name is too long to be correctly stored: %u\n",
+        (unsigned int) strlen(fileName)
       );
       return false;
@@ -120,5 +119,5 @@
     uint64_t &countersSum,
     uint64_t &countersMax
-  ) 
+  )
   {
     arcs_iterator_t	currentArc;
@@ -187,5 +186,5 @@
 
   void GcovFunctionData::printFunctionInfo(
-    FILE * textFile, 
+    FILE * textFile,
     uint32_t function_number
   )
@@ -231,5 +230,5 @@
 
   void GcovFunctionData::printCoverageInfo(
-    FILE     *textFile, 
+    FILE     *textFile,
     uint32_t  function_number
   )
@@ -255,9 +254,9 @@
         textFile,
         "\nInstructions (Base address: 0x%08x, Size: %4u): \n\n",
-        baseAddress, 
-        baseSize 
+        baseAddress,
+        baseSize
       );
-      for ( instruction = symbolInfo->instructions.begin(); 
-            instruction != symbolInfo->instructions.end(); 
+      for ( instruction = symbolInfo->instructions.begin();
+            instruction != symbolInfo->instructions.end();
             instruction++
       )
@@ -268,11 +267,11 @@
           fprintf( textFile, "| 0x%08x ",   currentAddress );
           fprintf( textFile, "*");
-          fprintf( textFile, 
-                    "| exec: %4u ", 
-                    coverageMap->getWasExecuted( currentAddress ) 
+          fprintf( textFile,
+                    "| exec: %4u ",
+                    coverageMap->getWasExecuted( currentAddress )
           );
           fprintf( textFile, "| taken/not: %4u/%4u ",
-                    coverageMap->getWasTaken( currentAddress ), 
-                    coverageMap->getWasNotTaken( currentAddress ) 
+                    coverageMap->getWasTaken( currentAddress ),
+                    coverageMap->getWasNotTaken( currentAddress )
           );
 
@@ -330,5 +329,5 @@
   }
 
-  void GcovFunctionData::printArcInfo( 
+  void GcovFunctionData::printArcInfo(
                 FILE * textFile, arcs_iterator_t arc
   )
@@ -369,9 +368,9 @@
         break;
     }
-    fprintf( textFile, "\tTaken: %5llu\n", (unsigned long long) arc->counter );
-  }
-
-  void GcovFunctionData::printBlockInfo( 
-    FILE * textFile, 
+    fprintf( textFile, "\tTaken: %5" PRIu64 "\n", (uint64_t) arc->counter );
+  }
+
+  void GcovFunctionData::printBlockInfo(
+    FILE * textFile,
     blocks_iterator_t block
   )
@@ -382,10 +381,10 @@
       textFile,
       " > BLOCK %3u from %s\n"
-      "    -counter: %5llu\n"
-      "    -flags: 0x%x\n"
+      "    -counter: %5" PRIu64 "\n"
+      "    -flags: 0x%" PRIx32 "\n"
       "    -lines: ",
       block->id,
       block->sourceFileName,
-      (unsigned long long) block->counter,
+      (uint64_t) block->counter,
       block->flags
     );
@@ -408,13 +407,13 @@
     std::list<uint64_t>    notTaken;    // List of not taken counts for branches
 
-    //fprintf( stderr, "DEBUG: Processing counters for file: %s\n", sourceFileName  ); 
+    //fprintf( stderr, "DEBUG: Processing counters for file: %s\n", sourceFileName  );
     if ( blocks.empty() || arcs.empty() || coverageMap == NULL || symbolInfo->instructions.empty())
     {
-      //fprintf( stderr, 
-      //          "DEBUG: sanity check returned false for function: %s from file: %s\n", 
-      //          functionName, 
-      //          sourceFileName 
+      //fprintf( stderr,
+      //          "DEBUG: sanity check returned false for function: %s from file: %s\n",
+      //          functionName,
+      //          sourceFileName
       //);
-      return false; 
+      return false;
     }
 
@@ -431,10 +430,10 @@
     if ( !processBranches( &taken , &notTaken ) )
     {
-      //fprintf( stderr, 
-      //          "ERROR: Failed to process branches for function: %s from file: %s\n", 
-      //          functionName, 
-      //          sourceFileName 
+      //fprintf( stderr,
+      //          "ERROR: Failed to process branches for function: %s from file: %s\n",
+      //          functionName,
+      //          sourceFileName
       //);
-      return false; 
+      return false;
     };
 
@@ -456,15 +455,15 @@
 
       // If this is a branch without FAKE arcs process it
-      if ( 
-        (arcIterator->sourceBlock == arcIterator2->sourceBlock ) && 
+      if (
+        (arcIterator->sourceBlock == arcIterator2->sourceBlock ) &&
         !( arcIterator->flags & FAKE_ARC_FLAG ) &&
-        !( arcIterator2->flags & FAKE_ARC_FLAG ) 
+        !( arcIterator2->flags & FAKE_ARC_FLAG )
       ) {
         if ( taken.empty() || notTaken.empty() ) {
           fprintf(
-            stderr, 
-            "ERROR: Branchess missing for function: %s from file: %s\n", 
-            functionName, 
-            sourceFileName 
+            stderr,
+            "ERROR: Branchess missing for function: %s from file: %s\n",
+            functionName,
+            sourceFileName
           );
           return false;
@@ -480,13 +479,13 @@
           notTaken.pop_front();
           arcIterator->counter = taken.front();
-          taken.pop_front();                   
+          taken.pop_front();
         }
 
         blockIterator2 = blocks.begin();
         //TODO: ADD FAILSAFE
-        while ( arcIterator->destinationBlock != blockIterator2->id) 	
+        while ( arcIterator->destinationBlock != blockIterator2->id)
           blockIterator2++;
         blockIterator2->counter += arcIterator->counter;
-  
+
         blockIterator2 = blocks.begin();
         //TODO: ADD FAILSAFE
@@ -494,5 +493,5 @@
             blockIterator2++;
           blockIterator2->counter += arcIterator2->counter;
-      }	    
+      }
       blockIterator++;
     }
@@ -520,8 +519,8 @@
       // If this is the last arc, propagate counter and exit
       if ( arcIterator2 == arcs.end() ) {
-        //fprintf( stderr, 
-        //        "DEBUG: Found last arc %3u -> %3u\n", 
-        //        arcIterator->sourceBlock, 
-        //        arcIterator->destinationBlock 
+        //fprintf( stderr,
+        //        "DEBUG: Found last arc %3u -> %3u\n",
+        //        arcIterator->sourceBlock,
+        //        arcIterator->destinationBlock
         //);
         arcIterator->counter = blockIterator->counter;
@@ -531,5 +530,5 @@
         blockIterator2->counter += arcIterator->counter;
         return true;
-      } 
+      }
 
       // If this is not a branch, propagate counter and continue
@@ -538,9 +537,9 @@
         arcIterator->counter = blockIterator->counter;
         blockIterator2 =  blocks.begin();;
-        while ( arcIterator->destinationBlock != blockIterator2->id) 	//TODO: ADD FAILSAFE 
+        while ( arcIterator->destinationBlock != blockIterator2->id) 	//TODO: ADD FAILSAFE
           blockIterator2++;
         blockIterator2->counter += arcIterator->counter;
       }
-	    
+
       // If this is  a branch with FAKE arc
       else if ( (arcIterator->sourceBlock == arcIterator2->sourceBlock ) && ( arcIterator2->flags & FAKE_ARC_FLAG ))
@@ -554,5 +553,5 @@
       }
 
-      // If this is a legitimate branch	    
+      // If this is a legitimate branch
       blockIterator++;
     }
@@ -560,8 +559,8 @@
     return true;
   }
-    
-  bool GcovFunctionData::processBranches( 
-            std::list<uint64_t> * taken , 
-            std::list<uint64_t> * notTaken 
+
+  bool GcovFunctionData::processBranches(
+            std::list<uint64_t> * taken ,
+            std::list<uint64_t> * notTaken
   )
   {
@@ -588,8 +587,8 @@
           taken->push_back ( (uint64_t) coverageMap->getWasTaken( currentAddress  ) );
           notTaken->push_back ( (uint64_t) coverageMap->getWasNotTaken( currentAddress ) );
-          //fprintf( stderr, 
+          //fprintf( stderr,
           //          "Added branch to list taken/not: %4u/%4u\n",
-          //          coverageMap->getWasTaken( currentAddress ), 
-          //          coverageMap->getWasNotTaken( currentAddress ) 
+          //          coverageMap->getWasTaken( currentAddress ),
+          //          coverageMap->getWasNotTaken( currentAddress )
           //);
         }
@@ -599,4 +598,2 @@
   }
 }
-
-
Index: tester/covoar/ObjdumpProcessor.cc
===================================================================
--- tester/covoar/ObjdumpProcessor.cc	(revision 09f4dbea55d1685f400e1475daed411a55ab74a7)
+++ tester/covoar/ObjdumpProcessor.cc	(revision 61410dbcc8d6521710702cf8ebc873058e1da0a4)
@@ -270,5 +270,4 @@
   {
     std::string     currentSymbol = "";
-    uint32_t        endAddress;
     uint32_t        instructionOffset;
     int             items;
@@ -277,5 +276,4 @@
     uint32_t        offset;
     bool            processSymbol = false;
-    uint32_t        startAddress = 0;
     char            symbol[ MAX_LINE_LENGTH ];
     char            terminator1;
@@ -349,6 +347,4 @@
       // If all items found, we are at the beginning of a symbol's objdump.
       if ((items == 3) && (terminator1 == ':')) {
-        endAddress = executableInformation->getLoadAddress() + offset - 1;
-
         // If we are currently processing a symbol, finalize it.
         if (processSymbol) {
@@ -361,5 +357,4 @@
 
         // Start processing of a new symbol.
-        startAddress = 0;
         currentSymbol = "";
         processSymbol = false;
@@ -368,5 +363,4 @@
         // See if the new symbol is one that we care about.
         if (SymbolsToAnalyze->isDesired( symbol )) {
-          startAddress = executableInformation->getLoadAddress() + offset;
           currentSymbol = symbol;
           processSymbol = true;
@@ -380,6 +374,4 @@
                && processSymbol )
       {
-        endAddress = executableInformation->getLoadAddress() + offset - 1;
-
         // If we are currently processing a symbol, finalize it.
         if ( processSymbol ) {