Index: c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/ChangeLog	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -1,2 +1,10 @@
+
+	* Makefile.am: ACLOCAL_AMFLAGS= -I $(RTEMS_TOPdir)/macros.
+        Switch to GNU canonicalization.
+
+2000-09-29	Charles-Antoine Gauthier <charles.gauthier@nrc.ca>
+
+	* startup/linkcmds: Added lines so DWARF debug information
+	would be available.  Otherwise gdb complains that the offsets
 	for the debug info are incorrect and doesn't load the files.
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/bootloader/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/bootloader/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/bootloader/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -18,4 +18,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
@@ -29,5 +30,6 @@
 
 AM_CPPFLAGS += -D__BOOT__ -DDEBUG -mrelocatable
-AM_CFLAGS += -msoft-float -mstrict-align -fno-builtin -Wall -mmultiple -mstring -O2 -fomit-frame-pointer -ffixed-r13 -mno-sdata
+AM_CFLAGS += -msoft-float -mstrict-align -fno-builtin -Wall -mmultiple \
+    -mstring -O2 -fomit-frame-pointer -ffixed-r13 -mno-sdata
 
 IMAGES = rtems.gz
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/clock/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/clock/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/clock/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -13,4 +13,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/console/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/console/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/console/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -16,4 +16,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/irq/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/irq/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/irq/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -19,4 +19,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/motorola/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/motorola/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/motorola/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -16,4 +16,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/openpic/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/openpic/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/openpic/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -14,4 +14,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/pci/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/pci/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/pci/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -15,4 +15,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/residual/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/residual/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/residual/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -15,4 +15,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/start/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/start/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/start/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -15,4 +15,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/startup/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/startup/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -14,4 +14,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/vectors/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/vectors/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/vectors/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -18,4 +18,5 @@
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/wrapup/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/wrapup/Makefile.am	(revision 761feae995c80450bb29ec3090cb1e74aa0aa3ac)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/wrapup/Makefile.am	(revision 068231cd91007d845932040949e1dc487fbc7c5e)
@@ -9,11 +9,12 @@
 # bummer; have to use $foreach since % pattern subst rules only replace 1x
 OBJS = $(foreach piece, $(BSP_PIECES), ../$(piece)/$(ARCH)/*.o) \
- $(wildcard ../../../../libcpu/$(RTEMS_CPU)/shared/*/$(ARCH)/*.o) \
- $(wildcard ../../../../libcpu/$(RTEMS_CPU)/mpc6xx/*/$(ARCH)/*.o) \
- $(wildcard ../../../../libcpu/powerpc/new_exception_processing/$(ARCH)/*.rel) \
- $(wildcard ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/*/$(ARCH)/*.o)
+    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/shared/*/$(ARCH)/*.o) \
+    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/mpc6xx/*/$(ARCH)/*.o) \
+    $(wildcard ../../../../libcpu/powerpc/new_exception_processing/$(ARCH)/*.rel) \
+    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/*/$(ARCH)/*.o)
 LIB = $(ARCH)/libbsp.a
 
 include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
 include $(top_srcdir)/../../../../../../automake/lib.am
 