Index: testsuites/psxtmtests/Makefile.am
===================================================================
--- testsuites/psxtmtests/Makefile.am	(revision 52c7cb1fdc69a032ca2859e1704412dc489ea0ac)
+++ testsuites/psxtmtests/Makefile.am	(revision 69812aaa2cee4123546af55510a8d6737cd11b07)
@@ -58,4 +58,15 @@
 endif
 
+if TEST_psxtmbarrierattr01
+psxtm_tests += psxtmbarrierattr01
+psxtm_docs += psxtmbarrierattr01/psxtmbarrierattr01.doc
+psxtmbarrierattr01_SOURCES = psxtmbarrierattr01/init.c \
+	../tmtests/include/timesys.h ../support/src/tmtests_empty_function.c \
+	../support/src/tmtests_support.c
+psxtmbarrierattr01_CPPFLAGS = $(AM_CPPFLAGS) $(TEST_FLAGS_psxtmbarrierattr01) \
+	$(support_includes) -I$(top_srcdir)/../tmtests/include \
+	-DOPERATION_COUNT=$(OPERATION_COUNT)
+endif
+
 if TEST_psxtmcleanup01
 psxtm_tests += psxtmcleanup01
Index: testsuites/psxtmtests/configure.ac
===================================================================
--- testsuites/psxtmtests/configure.ac	(revision 52c7cb1fdc69a032ca2859e1704412dc489ea0ac)
+++ testsuites/psxtmtests/configure.ac	(revision 69812aaa2cee4123546af55510a8d6737cd11b07)
@@ -35,4 +35,5 @@
 RTEMS_TEST_CHECK([psxtmbarrier03])
 RTEMS_TEST_CHECK([psxtmbarrier04])
+RTEMS_TEST_CHECK([psxtmbarrierattr01])
 RTEMS_TEST_CHECK([psxtmcleanup01])
 RTEMS_TEST_CHECK([psxtmclocknanosleep01])
Index: testsuites/psxtmtests/psxtmbarrierattr01/init.c
===================================================================
--- testsuites/psxtmtests/psxtmbarrierattr01/init.c	(revision 69812aaa2cee4123546af55510a8d6737cd11b07)
+++ testsuites/psxtmtests/psxtmbarrierattr01/init.c	(revision 69812aaa2cee4123546af55510a8d6737cd11b07)
@@ -0,0 +1,143 @@
+/*
+ *  COPYRIGHT (c) 2018.
+ *  Himanshu Sekhar Nayak( GCI 2018 )
+ *
+ *  Permission to use, copy, modify, and/or distribute this software
+ *  for any purpose with or without fee is hereby granted.
+ *
+ *  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
+ *  WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR
+ *  BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES
+ *  OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
+ *  WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
+ *  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <pthread.h>
+#include <tmacros.h>
+#include <timesys.h>
+#include <rtems/btimer.h>
+#include "test_support.h"
+
+const char rtems_test_name[] = "PSXTMBARRIERATTR01";
+
+/* forward declarations to avoid warnings */
+static void *POSIX_Init(void *argument);
+
+static pthread_barrierattr_t attr;
+
+static void benchmark_create_barrierattr(void)
+{
+  long end_time;
+  int  status;
+
+  benchmark_timer_initialize();
+  status = pthread_barrierattr_init( &attr );
+  end_time = benchmark_timer_read();
+  rtems_test_assert( status == 0 );
+
+  put_time(
+    "pthread_barrierattr_init: only case",
+    end_time,
+    1,        /* Only executed once */
+    0,
+    0
+  );
+
+}
+
+static void benchmark_barrierattr_setpshared(void)
+{
+  long end_time;
+  int  status;
+
+  benchmark_timer_initialize();
+  status = pthread_barrierattr_setpshared( &attr, PTHREAD_PROCESS_SHARED );
+  end_time = benchmark_timer_read();
+  rtems_test_assert( status == 0 );
+
+  put_time(
+    "pthread_barrierattr_setpshared: only case",
+    end_time,
+    1,        /* Only executed once */
+    0,
+    0
+  );
+
+}
+
+static void benchmark_barrierattr_getpshared(void)
+{
+  long end_time;
+  int  status;
+  int pshared;
+
+  benchmark_timer_initialize();
+  status = pthread_barrierattr_getpshared( &attr, &pshared );
+  end_time = benchmark_timer_read();
+  rtems_test_assert( status == 0 );
+  rtems_test_assert( pshared == PTHREAD_PROCESS_SHARED );
+
+  put_time(
+    "pthread_barrierattr_getpshared: only case",
+    end_time,
+    1,        /* Only executed once */
+    0,
+    0
+  );
+
+}
+
+static void benchmark_destroy_barrierattr(void)
+{
+  long end_time;
+  int  status;
+
+  benchmark_timer_initialize();
+  status = pthread_barrierattr_destroy( &attr );
+  end_time = benchmark_timer_read();
+  rtems_test_assert( status == 0 );
+
+  put_time(
+    "pthread_barrierattr_destroy: only case",
+    end_time,
+    1,        /* Only executed once */
+    0,
+    0
+  );
+
+}
+
+static void *POSIX_Init(
+  void *argument
+)
+{
+
+  TEST_BEGIN();
+
+  benchmark_create_barrierattr();
+  benchmark_barrierattr_setpshared();
+  benchmark_barrierattr_getpshared();
+  benchmark_destroy_barrierattr();
+
+  TEST_END();
+  rtems_test_exit(0);
+}
+
+/* configuration information */
+
+#define CONFIGURE_APPLICATION_NEEDS_SIMPLE_CONSOLE_DRIVER
+#define CONFIGURE_APPLICATION_NEEDS_TIMER_DRIVER
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS     1
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_INIT
+
+#include <rtems/confdefs.h>
+/* end of file */
Index: testsuites/psxtmtests/psxtmtests_plan.csv
===================================================================
--- testsuites/psxtmtests/psxtmtests_plan.csv	(revision 52c7cb1fdc69a032ca2859e1704412dc489ea0ac)
+++ testsuites/psxtmtests/psxtmtests_plan.csv	(revision 69812aaa2cee4123546af55510a8d6737cd11b07)
@@ -92,4 +92,9 @@
 "pthread_barrier_wait: releasing: preempt","psxtmbarrier04","psxtmtest_unblocking_preempt","Yes"
 
+"pthread_barrierattr_init: only case","psxtmbarrierattr01","psxtmtest_init_destroy","Yes"
+"pthread_barrierattr_destroy: only case","psxtmbarrierattr01","psxtmtest_init_destroy","Yes"
+"pthread_barrierattr_getpshared: only case","psxtmbarrierattr01","psxtmtest_single","Yes"
+"pthread_barrierattr_setpshared: only case","psxtmbarrierattr01","psxtmtest_single","Yes"
+
 "pthread_spin_init: only case","psxspin01","psxtmtest_init_destroy","Yes"
 "pthread_spin_destroy: only case","psxspin01","psxtmtest_init_destroy","Yes"