Index: c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137.inc
===================================================================
--- c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137.inc	(revision 74172b7da07c5e5b18b81a8c0d1036620f56ecdb)
+++ c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137.inc	(revision 74172b7da07c5e5b18b81a8c0d1036620f56ecdb)
@@ -0,0 +1,20 @@
+#
+# Config file for TMS570LS3137 board.
+#
+
+include $(RTEMS_ROOT)/make/custom/default.cfg
+
+RTEMS_CPU = arm
+
+CPU_CFLAGS = -march=armv7-r -mthumb -mbig-endian -mfpu=vfpv3-d16 -mfloat-abi=hard
+
+CFLAGS_OPTIMIZE_V = -O2 -ggdb
+BINEXT?=.bin
+
+# This defines the operations performed on the linked executable.
+# is currently required.
+define bsp-post-link
+    $(OBJCOPY) -O binary --strip-all \
+        $(basename $@)$(EXEEXT) $(basename $@)$(BINEXT)
+    $(SIZE) $(basename $@)$(EXEEXT)
+endef
Index: c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk.cfg
===================================================================
--- c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk.cfg	(revision 38404cb42c2dc0bf83cad835635d07a41dda3956)
+++ c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk.cfg	(revision 74172b7da07c5e5b18b81a8c0d1036620f56ecdb)
@@ -3,18 +3,3 @@
 #
 
-include $(RTEMS_ROOT)/make/custom/default.cfg
-
-RTEMS_CPU = arm
-
-CPU_CFLAGS = -march=armv7-r -mthumb -mbig-endian -mfpu=vfpv3-d16 -mfloat-abi=hard
-
-CFLAGS_OPTIMIZE_V = -O2 -ggdb
-BINEXT?=.bin
-
-# This defines the operations performed on the linked executable.
-# is currently required.
-define bsp-post-link
-    $(OBJCOPY) -O binary --strip-all \
-        $(basename $@)$(EXEEXT) $(basename $@)$(BINEXT)
-    $(SIZE) $(basename $@)$(EXEEXT)
-endef
+include $(RTEMS_ROOT)/make/custom/tms570ls3137.inc
Index: c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_intram.cfg
===================================================================
--- c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_intram.cfg	(revision 38404cb42c2dc0bf83cad835635d07a41dda3956)
+++ c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_intram.cfg	(revision 74172b7da07c5e5b18b81a8c0d1036620f56ecdb)
@@ -3,18 +3,3 @@
 #
 
-include $(RTEMS_ROOT)/make/custom/default.cfg
-
-RTEMS_CPU = arm
-
-CPU_CFLAGS = -march=armv7-r -mthumb -mbig-endian
-
-CFLAGS_OPTIMIZE_V = -O2 -ggdb
-BINEXT?=.bin
-
-# This defines the operations performed on the linked executable.
-# is currently required.
-define bsp-post-link
-    $(OBJCOPY) -O binary --strip-all \
-        $(basename $@)$(EXEEXT) $(basename $@)$(BINEXT)
-    $(SIZE) $(basename $@)$(EXEEXT)
-endef
+include $(RTEMS_ROOT)/make/custom/tms570ls3137.inc
Index: c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_sdram.cfg
===================================================================
--- c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_sdram.cfg	(revision 38404cb42c2dc0bf83cad835635d07a41dda3956)
+++ c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_sdram.cfg	(revision 74172b7da07c5e5b18b81a8c0d1036620f56ecdb)
@@ -3,18 +3,3 @@
 #
 
-include $(RTEMS_ROOT)/make/custom/default.cfg
-
-RTEMS_CPU = arm
-
-CPU_CFLAGS = -march=armv7-r -mthumb -mbig-endian
-
-CFLAGS_OPTIMIZE_V = -O2 -ggdb
-BINEXT?=.bin
-
-# This defines the operations performed on the linked executable.
-# is currently required.
-define bsp-post-link
-    $(OBJCOPY) -O binary --strip-all \
-        $(basename $@)$(EXEEXT) $(basename $@)$(BINEXT)
-    $(SIZE) $(basename $@)$(EXEEXT)
-endef
+include $(RTEMS_ROOT)/make/custom/tms570ls3137.inc
Index: c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_with_loader.cfg
===================================================================
--- c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_with_loader.cfg	(revision 38404cb42c2dc0bf83cad835635d07a41dda3956)
+++ c/src/lib/libbsp/arm/tms570/make/custom/tms570ls3137_hdk_with_loader.cfg	(revision 74172b7da07c5e5b18b81a8c0d1036620f56ecdb)
@@ -3,18 +3,3 @@
 #
 
-include $(RTEMS_ROOT)/make/custom/default.cfg
-
-RTEMS_CPU = arm
-
-CPU_CFLAGS = -march=armv7-r -mthumb -mbig-endian -mfpu=vfpv3-d16 -mfloat-abi=hard
-
-CFLAGS_OPTIMIZE_V = -O2 -ggdb
-BINEXT?=.bin
-
-# This defines the operations performed on the linked executable.
-# is currently required.
-define bsp-post-link
-    $(OBJCOPY) -O binary --strip-all \
-        $(basename $@)$(EXEEXT) $(basename $@)$(BINEXT)
-    $(SIZE) $(basename $@)$(EXEEXT)
-endef
+include $(RTEMS_ROOT)/make/custom/tms570ls3137.inc